VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsRegistry"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As Long, ByVal lpValueName As String) As Long
'--------------------------------------------------
Private Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, ByVal cbName As Long) As Long
Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, lpcbValueName As Long, lpReserved As Long, lpType As Long, lpData As Byte, lpcbData As Long) As Long
'--------------------------------------------------
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long

Const HKEY_CLASSES_ROOT = &H80000000
Const HKEY_CURRENT_USER = &H80000001
Const HKEY_LOCAL_MACHINE = &H80000002
Const HKEY_USERS = &H80000003
Const HKEY_PERFORMANCE_DATA = &H80000004
Const HKEY_CURRENT_CONFIG = &H80000005
Const HKEY_DYN_DATA = &H80000006
Const REG_SZ = 1                         ' Unicode nul terminated string
Const REG_BINARY = 3                     ' Free form binary
Const REG_DWORD = 4                      ' 32-bit number
Const ERROR_SUCCESS = 0&

Enum RegHKey
  Classes_Root = 0
  Current_User = 1
  Local_Machine = 2
  Users = 3
  Current_Config = 4
  Dyn_Data = 5
End Enum

Public regKey As RegHKey
Private mKey As Long

Private Function GetKey(hKey As RegHKey)
  
  If hKey = Classes_Root Then
    GetKey = HKEY_CLASSES_ROOT
  ElseIf hKey = Current_Config Then
    GetKey = HKEY_CURRENT_CONFIG
  ElseIf hKey = Current_User Then
    GetKey = HKEY_CURRENT_USER
  ElseIf hKey = Dyn_Data Then
    GetKey = HKEY_DYN_DATA
  ElseIf hKey = Local_Machine Then
    GetKey = HKEY_LOCAL_MACHINE
  ElseIf hKey = Users Then
    GetKey = HKEY_USERS
  End If
  
End Function

Public Sub CreateKey(hKey As RegHKey, strPath As String)
Dim hCurKey As Long
Dim lRegResult As Long

hKey = GetKey(hKey)
lRegResult = RegCreateKey(hKey, strPath, hCurKey)

If lRegResult <> ERROR_SUCCESS Then
  ' there is a problem
End If

lRegResult = RegCloseKey(hCurKey)

End Sub

Public Sub DeleteKey(ByVal hKey As RegHKey, ByVal strPath As String)
Dim lRegResult As Long

hKey = GetKey(hKey)
lRegResult = RegDeleteKey(hKey, strPath)

End Sub

Public Sub DeleteValue(ByVal hKey As RegHKey, ByVal strPath As String, ByVal strValue As String)
Dim hCurKey As Long
Dim lRegResult As Long

hKey = GetKey(hKey)
lRegResult = RegOpenKey(hKey, strPath, hCurKey)

lRegResult = RegDeleteValue(hCurKey, strValue)

lRegResult = RegCloseKey(hCurKey)

End Sub

Public Function GetSettingString(hKey As RegHKey, strPath As String, strValue As String, Optional Default As String) As String
Dim hCurKey As Long
Dim lValueType As Long
Dim strBuffer As String
Dim lDataBufferSize As Long
Dim intZeroPos As Integer
Dim lRegResult As Long

' Set up default value
If Not IsEmpty(Default) Then
  GetSettingString = Default
Else
  GetSettingString = ""
End If


hKey = GetKey(hKey)

' Open the key and get length of string
lRegResult = RegOpenKey(hKey, strPath, hCurKey)
lRegResult = RegQueryValueEx(hCurKey, strValue, 0&, lValueType, ByVal 0&, lDataBufferSize)

If lRegResult = ERROR_SUCCESS Then

  If lValueType = REG_SZ Then
    ' initialise string buffer and retrieve string
    strBuffer = String(lDataBufferSize, " ")
    lRegResult = RegQueryValueEx(hCurKey, strValue, 0&, 0&, ByVal strBuffer, lDataBufferSize)
    
    ' format string
    intZeroPos = InStr(strBuffer, Chr$(0))
    If intZeroPos > 0 Then
      GetSettingString = Left(strBuffer, intZeroPos - 1)
    Else
      GetSettingString = strBuffer
    End If

  End If

Else
  ' there is a problem
End If

lRegResult = RegCloseKey(hCurKey)
End Function

Public Sub SaveSettingString(hKey As RegHKey, strPath As String, strValue As String, strData As String)
Dim hCurKey As Long
Dim lRegResult As Long

hKey = GetKey(hKey)
lRegResult = RegCreateKey(hKey, strPath, hCurKey)

lRegResult = RegSetValueEx(hCurKey, strValue, 0, REG_SZ, ByVal strData, Len(strData))

If lRegResult <> ERROR_SUCCESS Then
  'there is a problem
End If

lRegResult = RegCloseKey(hCurKey)
End Sub

Public Function GetSettingLong(ByVal hKey As RegHKey, ByVal strPath As String, ByVal strValue As String, Optional Default As Long) As Long

Dim lRegResult As Long
Dim lValueType As Long
Dim lBuffer As Long
Dim lDataBufferSize As Long
Dim hCurKey As Long

hKey = GetKey(hKey)
' Set up default value
If Not IsEmpty(Default) Then
  GetSettingLong = Default
Else
  GetSettingLong = 0
End If

lRegResult = RegOpenKey(hKey, strPath, hCurKey)
lDataBufferSize = 4       ' 4 bytes = 32 bits = long

lRegResult = RegQueryValueEx(hCurKey, strValue, 0&, lValueType, lBuffer, lDataBufferSize)

If lRegResult = ERROR_SUCCESS Then

  If lValueType = REG_DWORD Then
    GetSettingLong = lBuffer
  End If

Else
  'there is a problem
End If

lRegResult = RegCloseKey(hCurKey)

End Function

Public Sub SaveSettingLong(ByVal hKey As RegHKey, ByVal strPath As String, ByVal strValue As String, ByVal lData As Long)
Dim hCurKey As Long
Dim lRegResult As Long

hKey = GetKey(hKey)
lRegResult = RegCreateKey(hKey, strPath, hCurKey)

lRegResult = RegSetValueEx(hCurKey, strValue, 0&, REG_DWORD, lData, 4)

If lRegResult <> ERROR_SUCCESS Then
  'there is a problem
End If

lRegResult = RegCloseKey(hCurKey)
End Sub

Public Function GetSettingByte(ByVal hKey As RegHKey, ByVal strPath As String, ByVal strValueName As String, Optional Default As Variant) As Variant
Dim lValueType As Long
Dim byBuffer() As Byte
Dim lDataBufferSize As Long
Dim lRegResult As Long
Dim hCurKey As Long

hKey = GetKey(hKey)

' setup default value
If Not IsEmpty(Default) Then
  If VarType(Default) = vbArray + vbByte Then
    GetSettingByte = Default
  Else
    GetSettingByte = 0
  End If

Else
  GetSettingByte = 0
End If

' Open the key and get number of bytes
lRegResult = RegOpenKey(hKey, strPath, hCurKey)
lRegResult = RegQueryValueEx(hCurKey, strValueName, 0&, lValueType, ByVal 0&, lDataBufferSize)

If lRegResult = ERROR_SUCCESS Then

  If lValueType = REG_BINARY Then
  
    ' initialise buffers and retrieve value
    ReDim byBuffer(lDataBufferSize - 1) As Byte
    lRegResult = RegQueryValueEx(hCurKey, strValueName, 0&, lValueType, byBuffer(0), lDataBufferSize)
    
    GetSettingByte = byBuffer

  End If

Else
  'there is a problem
End If

lRegResult = RegCloseKey(hCurKey)

End Function

Public Sub SaveSettingByte(ByVal hKey As RegHKey, ByVal strPath As String, ByVal strValueName As String, byData() As Byte)
' Make sure that the array starts with element 0 before passing it!
' (otherwise it will not be saved!)

Dim lRegResult As Long
Dim hCurKey As Long

hKey = GetKey(hKey)
lRegResult = RegCreateKey(hKey, strPath, hCurKey)

' & = 0
End If

' Open the key and get number of bytes
lReEnd Ifkgn0Hy, ByVasey(hKey, strPath, hCsDataBuffTltrPath,Aues, ByVasey(hKeyrm lDataBufferSize As Long
Dim intZeroPos As Integer
Dim lRegResult As Long
 hCsDataB
    ' ind get (hKVcte
   tEsMPsraa>0, LeflRegResuSesuSesubByte Then
  ACi b TheR
  ACi b TheR
  ACtYR(strData))g
 h If VarType(Default) = vbArray + vbByte Then
    Getype(Default) H b teser oE5sma_H b teser oE5sma_H b teser oE5sma_H b teser oE5sma_H b teser oE5sma_H b teser oE5sma_H b teser oEdteser ble TheR
  AC As Long
Dim byBuffer() As Byte
Dim im )im )im 
   l_tesedIma_H b teser oE5W5trPath, hCurKey)f bytes
eeR
  ACi b TheR
i b r osma_H b teser oEre thatPubli = vbArray + vkgn0n = RegCreateKey(hKey, strPe thstrPang

hre thatPubli = vbArray + D = vbAeLong

hegSetVeTsbACi b TheR
  AiPubli = vbArray + D = (hKVcte
   tEstrVa3reyda2 5ath, hCurKey)f bytesPsValueType, byBuffer(0), lDataBufferSize)
    
    GetSettSiBuffer(yBufferResult At As Long

hKey = GetKey(hKey)
lRegResult = RegDeleteytes
eeR
  ACi  e6clt As Long
 hC RegsultEx(hteytResult = Re1ult yrm fer(0), dn(strData))

If lRegResult <> Eytet IfBytctroblemute VB_PreBuffer(yBufferResult At As Long
artolse buffers andalue
lRegResult b TheR
  AiPubli = vbArray + D = (hKVcte
   tEstse buf_RwY
artolse buffers andaSke savet up defrm lDataBufferSize As Long
Dim intZeroPos As Integer
Dim lRegResult As Long
 hCsDatSsim intZslDt lt As Long
 hClRegResultKey = Gers andaSke savet As t <> EyGers andaSke N = bb byBuffer

intealu <> EyGers andaSke N = bb byBuffer
uD vkgn0n = RegCreateKey(hKey, strPe thstrPang

hre thatPubli = vbrPe nPFD  ACiLing

hre thatPubli = vbrPe nPFD  ACiLing

hre thatPublVcte
lRegResuly
yData=-CreateKey(hKey, strPe thstrPaesitrm lDataBuffersflRegResuSesuSesBuffeurKrsflRegResuSesuffer
uD vpResuSesuSesBuffeurKrsflRegResuSesuffer
uD vpResuSesuSasey(hpthatfferSize)
    
    GetSettingByte = byBuffer

 RegResuSethat sheR
  :uSe ThTLreateKey(hKeuerSize)
    
    GetSettingBytt <> Ey  
rs
hbE0s"    lslve_E ACiLing
tH  sGteo1ult yrm fer(0),sBuffeurKrsflRegResuSesuffer
uD vpResuSesuSasey(hpthatfferSize)
    
    GetSettingByte = byBuffer

 RegResuSs  GetSettingByk  oE5smaBBufwAs Long
 hlt yrm <> EyGers andaSke N = bb byBuffer

intealu <>"LreateferTrshKeli = vbArray + D = vbAeLon"wKey, siE4pD = (hKtO"viKey, siE4pD = (hKtO"viKey, siE4pD = (hKtO"viKey, siE4pD = (hKtO"viKey, siE4pD = (hKtO"viKey, siE4pD = (hKtO"viKey, siE4pD = (hKtO"ic Sub 
rs
Rhatfft_ _ic SuiE4pD = (hKtO"viKey, siECegResult As etSettingByte = khKtOttingByte = khKtT_RwY
artolse buffers andaSke savet up defrm lDataBufferStT_RwY
artolseRrs
Rhatfft_ E5sma_H b teser oE5sma_H b teser oE5sma_H b tese, 4)

tingByte = Sy, siEsma_H bDssma_H btingByte = Sy, siEsma_H bDssma_H btivpOptiath, hCurKey)f GetKey(hKetolsmsiIe siESrSsBuffeurKrsf